﻿using ClassLibrary1.ServiceReference1;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.ServiceModel;
using System.Threading.Tasks;
using System.Windows;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace Views.Pages
{
    public sealed partial class MainPage : Page
    {
        public MainPage() {
            this.InitializeComponent();

            // Enter construction logic here...
        }
        Service1Client _soapClient =
        new Service1Client(
            new System.ServiceModel.BasicHttpBinding(),
            new System.ServiceModel.EndpointAddress(
                new Uri("http://localhost/WcfService1/Service1.svc")));

        void ButtonRefreshSoapToDos_Click(object sender, RoutedEventArgs e) {
            //var todos = await GetData();
            var todos = _soapClient.GetToDos();
            SoapToDosItemsControl.ItemsSource = todos;
        }

        void ButtonAddSoapToDo_Click(object sender, RoutedEventArgs e) {
            var todo = new ToDoItem() {
                Dt = DateTime.Now,
                Description = SoapToDoTextBox.Text,
                Id = Guid.NewGuid()
            };
            _soapClient.AddOrUpdateToDo(todo);
            ButtonRefreshSoapToDos_Click(sender, e);
        }

        void ButtonDeleteSoapToDo_Click(object sender, RoutedEventArgs e) {
            try {
                var todo = (ToDoItem)((Button)sender).DataContext;
                _soapClient.DeleteToDo(todo);
                ButtonRefreshSoapToDos_Click(sender, e);
            } catch (System.ServiceModel.FaultException ex) {
                // Fault exceptions allow the server to pass information such as "Item not found":
                System.Windows.MessageBox.Show(ex.Message);
            }
        }

        async Task<ToDoItem[]> GetData() {
            ToDoItem[] pcs = new ToDoItem[1];
            try {
                GetToDosResponse list = await _soapClient.GetToDosAsync();
                pcs = list.Body.GetToDosResult;

            } catch (Exception ex) {
                MessageBox.Show(ex.Message);
            }
            return pcs;
        }
    }
}
